diff options
| author | Michael Biebl <biebl@debian.org> | 2024-05-05 00:07:30 +0200 |
|---|---|---|
| committer | Michael Biebl <biebl@debian.org> | 2024-05-05 00:07:30 +0200 |
| commit | 34bb501be08aa2b313d88e67d6e0a7e0a3f9cfa6 (patch) | |
| tree | 4e6220877828be4c6f261de09ec0cb2d80e32389 /contrib/scripts/git-backport-merge | |
| parent | bba2e4b4de668db525cbfdfc35292e5a0b51671a (diff) | |
New upstream version 1.47.90 upstream/1.47.90
Diffstat (limited to 'contrib/scripts/git-backport-merge')
| -rwxr-xr-x | contrib/scripts/git-backport-merge | 58 |
1 files changed, 58 insertions, 0 deletions
diff --git a/contrib/scripts/git-backport-merge b/contrib/scripts/git-backport-merge new file mode 100755 index 00000000..8ba2244f --- /dev/null +++ b/contrib/scripts/git-backport-merge @@ -0,0 +1,58 @@ +#!/bin/bash + +# Uses `git cherry-pick -x` to backport a merge commit to an older branch. +# +# Usage: +# First checkout the old-stable branch, that is the target for the backport. +# Then `git-backport-merge MERGE_REF [REFS...]` +# MERGE_REF is the merge commit that should be backported. +# [REFS...] is the commits that should be backported. If omitted, +# it automatically takes the parent commits of the merge commit. + +die() { + printf '%s\n' "$*" >&2 + exit 1 +} + +backport_merge() { + test "$#" -gt 0 || die "Requires the commit ref to backport (and optimally select the commits to include)" + + local M="${@:$#}" + local h + + if test "$#" -eq 1; then + local C=($(git log --reverse "--pretty=%H" "$M"^1.."$M"^2)) + else + local C=("${@:1:$#-1}") + fi + + local OLD_HEAD="$(git rev-parse HEAD)" || die "failed to get current HEAD" + + test -n "$(git status --porcelain --untracked-files=no)" && die "Working directory contains changes. Abort." + + local M_ID="$(git rev-parse "$M"^{commit})" || die "\"$M\" is not a valid commit" + + trap EXIT 'test -z "$OLD_HEAD" || git reset "$OLD_HEAD" --hard' + + for h in "${C[@]}"; do + if ! git cherry-pick --allow-empty -x "$h" ; then + git cherry-pick --abort + die "failed to cherry-pick commit \"$h\" on top of \"$(git rev-parse HEAD)\"" + fi + done + + local NEW_HEAD="$(git rev-parse HEAD)" || die "failed to get new HEAD" + + git reset --hard "$OLD_HEAD" || die "Failed to reset to previous HEAD \"$OLD_HEAD\"" + + git merge --no-ff --no-edit "$NEW_HEAD" || die "Failed to merge old HEAD \"$OLD_HEAD\" with new \"$NEW_HEAD\"" + + git commit --amend --allow-empty -C "$M" || die "Failed to amend merge commit \"$(git rev-parse HEAD)\" with commit message from \"$M\"" + + git rev-parse "$M" | sed 's/.*/(cherry picked from commit \0)/' | GIT_EDITOR='sh -c "cat >> \"$1\""' git commit --allow-empty --amend || \ + die "Failed to amend merge commit \"$(git rev-parse HEAD)\" with cherry-picked-from message from \"$M\"" + + OLD_HEAD= +} + +backport_merge "$@" |